" Vim syntax file
" Language:	Limbo
" Maintainer:	Mocha Blendy <mocha@cameo.plala.or.jp>
" Last Change:	2003 May 22

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

syn clear

syn match	ldelimiter	"[\[\];,]"
syn match	loperator	"(<-\|->\|=>\|:=\|::)"
syn keyword	loperator	hd tl ref tagof len
syn keyword	ltype		int byte string big real array list tuple chan
syn keyword     ltype           of con fn
syn keyword	lstructure	adt pick
syn keyword	lrepeat		for while do continue break
syn keyword	lcondition	if else case or alt
syn keyword	lkeyword	exit spawn
syn keyword	lkeyword	implement module include import load
syn keyword     lkeyword        nil
syn keyword     lkeyword        self return
syn keyword     lexception	raise exception
syn keyword     lkeyword        cyclic to type
syn region	lstring		start=+'+ skip=+\\'+ end=+'+
syn region	lstring		start=+"+ skip=+\\"+ end=+"+
syn match	lnumber		"[0-9]"
syn keyword	ltodo		TODO BUG FIXME XXX DEBUG contained
syn match	lcomment	"#\s*.*" contains=ltodo
syn match	lincluded	display contained "\"[^"]*\""
syn match	linclude	"^\s*include\>\s*["]" contains=lincluded

if !exists("did_limbo_syntax_inits")
    let did_limbo_syntax_inits = 1
    hi link ldelimiter	Delimiter
    hi link loperator	Operator
    hi link lcomment	Comment
    hi link ltype	Type
    hi link lstructure	Structure
    hi link lkeyword	Keyword
    hi link lexception	Keyword
    hi link lstring	String
    hi link lnumber	Number
    hi link lrepeat	Repeat
    hi link lcondition	Conditional
    hi link linclude	Include
    hi link ltodo	Todo
endif

let b:current_syntax = "limbo"


